Attribute VB_Name = "mdlDeclare"
'[Costanti]
Public Const NM_FIRST = -0&
Public Const NM_CUSTOMDRAW = (NM_FIRST - 12)
Public Const CDRF_DODEFAULT = &H0
Public Const CDRF_NOTIFYPOSTPAINT = &H10
Public Const CDRF_NOTIFYITEMDRAW = &H20
Public Const CDRF_NOTIFYPOSTERASE = &H40
Public Const CDRF_NOTIFYITEMERASE = &H80
Public Const CDRF_NEWFONT = &H2
Public Const CDRF_SKIPDEFAULT = &H4
Public Const CDRF_NOTIFYSUBITEMDRAW = &H20
Public Const WM_SETREDRAW = &HB
Private Const WM_NOTIFY = &H4E
Private Const WM_DESTROY = &H2
Private Const OLDWNDPROC = "OldWndProc"
Private Const OBJECTPTR = "ObjectPtr"
Private Const WM_HSCROLL As Integer = &H114
Private Const WM_VSCROLL As Integer = &H115


'[Notifiche del customdraw]
Public Enum CD_DrawStage
    CDDS_PREPAINT = &H1
    CDDS_POSTPAINT = &H2
    CDDS_PREERASE = &H3
    CDDS_POSTERASE = &H4
    CDDS_ITEM = &H10000
    CDDS_ITEMPREPAINT = (CDDS_ITEM Or CDDS_PREPAINT)
    cdds_itempostpaint = (CDDS_ITEM Or CDDS_POSTPAINT)
    CDDS_ITEMPREERASE = (CDDS_ITEM Or CDDS_PREERASE)
    CDDS_ITEMPOSTERASE = (CDDS_ITEM Or CDDS_POSTERASE)
    CDDS_SUBITEM = &H20000
End Enum

'[stato del subitem]
Public Enum CD_ItemState
    CDIS_SELECTED = &H1
    CDIS_GRAYED = &H2
    CDIS_DISABLED = &H4
    CDIS_CHECKED = &H8
    CDIS_FOCUS = &H10
    CDIS_DEFAULT = &H20
    CDIS_HOT = &H40
    CDIS_MARKED = &H80
    CDIS_INDETERMINATE = &H100
End Enum

Public Type NMHDR
    hwndFrom As Long
    idFrom As Long
    code  As Long
End Type

Public Type NMHEADER
    hdr As NMHDR
    iItem As Long
    iButton As Long
    lPtrHDItem As Long
End Type

Public Type rect
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Public Type NMCUSTOMDRAW   ' nmcd
    hdr As NMHDR
    dwDrawStage As CD_DrawStage
    hdc As Long
    rc As rect
    dwItemSpec As Long
    uItemState As CD_ItemState
    lItemlParam As Long
End Type
    
Public Type NMTTCUSTOMDRAW
    nmcd As NMCUSTOMDRAW
    uDrawFlags As Long
End Type

Public Type NMLVCUSTOMDRAW
    nmcd As NMCUSTOMDRAW
    clrText As Long
    clrTextBk As Long
    iSubItem As Long
End Type

Public Type HDITEM
  mask As Long
  cxy As Long
  pszText As String
  hbm As Long
  cchTextMax As Long
  fmt As Long
  lParam As Long
  iImage As Long
  iOrder As Long
End Type

Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function GetProp Lib "user32" Alias "GetPropA" (ByVal hWnd As Long, ByVal lpString As String) As Long
Private Declare Function SetProp Lib "user32" Alias "SetPropA" (ByVal hWnd As Long, ByVal lpString As String, ByVal hData As Long) As Long
Private Declare Function RemoveProp Lib "user32" Alias "RemovePropA" (ByVal hWnd As Long, ByVal lpString As String) As Long
Private Declare Sub MoveMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSource As Any, ByVal dwLength As Long)
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As GWL_nIndex) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As GWL_nIndex, ByVal dwNewLong As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Public Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long


Public Enum GWL_nIndex
  GWL_WNDPROC = (-4)
  GWL_ID = (-12)
  GWL_STYLE = (-16)
  GWL_EXSTYLE = (-20)
End Enum


Private lpPrevWndProc As Long
Public gHW As Long

Public Function UnSubClass(hWnd As Long) As Boolean
Dim lpfnOld As Long
lpfnOld = GetProp(hWnd, OLDWNDPROC)
If lpfnOld Then
    If SetWindowLong(hWnd, GWL_WNDPROC, lpfnOld) Then
        Call RemoveProp(hWnd, OLDWNDPROC)
        Call RemoveProp(hWnd, OBJECTPTR)
        UnSubClass = True
    End If
End If
End Function
Public Function SubClass(hWnd As Long, lpfnNew As Long) As Boolean
  Dim lpfnOld As Long
  Dim fSuccess As Boolean
  
  If (GetProp(hWnd, OLDWNDPROC) = 0) Then
    lpfnOld = SetWindowLong(hWnd, GWL_WNDPROC, lpfnNew)
    If lpfnOld Then
      fSuccess = SetProp(hWnd, OLDWNDPROC, lpfnOld)
    End If
  End If
  
  If fSuccess Then
    SubClass = True
  Else
    If lpfnOld Then Call UnSubClass(hWnd)
  End If
End Function
Public Function WndProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Static lvcd As NMLVCUSTOMDRAW
   
Select Case uMsg
    Case WM_NOTIFY
        MoveMemory lvcd, ByVal lParam, Len(lvcd)
        Select Case lvcd.nmcd.hdr.code
            Case NM_CUSTOMDRAW
                Static iElement As Long
                Select Case lvcd.nmcd.dwDrawStage
                    Case CDDS_PREPAINT
                        WndProc = CDRF_NOTIFYITEMDRAW
                        Exit Function
                    Case CDDS_ITEMPREPAINT
                        MoveMemory ByVal lParam, lvcd, Len(lvcd)
                        WndProc = CDRF_NOTIFYSUBITEMDRAW Or CDRF_NEWFONT
                        Exit Function
                    Case (CDDS_ITEMPREPAINT Or CDDS_SUBITEM)
                        If lvcd.iSubItem = 2 Then
                            lvcd.clrTextBk = vbYellow
                        End If
                        MoveMemory ByVal lParam, lvcd, Len(lvcd)
                        WndProc = CDRF_NEWFONT
                        Exit Function
                End Select
        End Select

    Case WM_DESTROY
        Call CallWindowProc(GetProp(hWnd, OLDWNDPROC), hWnd, uMsg, wParam, lParam)
        Call UnSubClass(hWnd)
        Exit Function
End Select
WndProc = CallWindowProc(GetProp(hWnd, OLDWNDPROC), hWnd, uMsg, wParam, lParam)
End Function


